﻿// <summary>ソースコード：ＨＹＭＣＯサンプルモデルファクトリクラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.Interface.HSViewer;
using CommonMP.HYSSOP.CoreImpl;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

using CommonMP.HYMCO.Interface;
using CommonMP.HYMCO.Interface.Model;
using CommonMP.HYMCO.Interface.Data;
using CommonMP.HYMCO.Interface.Controller;

using CommonMP.HYMCO.CoreImpl.Model;
using CommonMP.HYMCO.CoreImpl.Data;

using CommonMP.HYMCO._SYSTEM_;

namespace CommonMP.HYMCO._SYSTEM_
{
    /// <summary><para>class outline:</para>
    /// <para>ＨＹＭＣＯモデルファクトリ生成</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2009/10/01][新規作成]</para>
    /// </remarks>
    public class HYMCO_MODEL_FACTORY_CREATOR_IMPLE : HYMCO_MODEL_FACTORY_CREATOR
    {
        /// <summary><para>method outline:</para>
        /// <para>コンストラクター</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HYMCO_MODEL_FACTORY_CREATOR_IMPLE csFactCrt = new HYMCO_MODEL_FACTORY_CREATOR_IMPLE( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>生成インスタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public HYMCO_MODEL_FACTORY_CREATOR_IMPLE()
        {
        }
        /// <summary><para>method outline:</para>
        /// <para>演算モデルファクトリクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McModelFactory csCalModelFactory = CreateFactory( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>演算モデルファクトリクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public CommonMP.HYMCO.Interface.Model.McModelFactory CreateFactory()
        {
            return new jp.or.jccajsce.KinematicWaveRiverModel.KinematicWaveRiverModelFactory();
        }
    }
}

        namespace jp.or.jccajsce.KinematicWaveRiverModel
{
    /// <summary><para>class outline:</para>
    /// <para>サンプルモデルファクトリクラス</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class KinematicWaveRiverModelFactory : McBasicModelFactoryBase
    {
        /// <summary><para>method outline:</para>
        /// <para>デフォルトコンストラクタ</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para>McSampleModelFactory csFactory = new McSampleModelFactory()</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>インスタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public KinematicWaveRiverModelFactory( )
        {
        }

        /// <summary><para>method outline:</para>
        /// <para>ファクトリ識別子を生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HySID csFactID = CreateFactoryID( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>ファクトリ識別子</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override HySID CreateFactoryID()
        {
            return KinematicWaveRiverDefine.KinematicWaveRiverModel_Factory;
        }

        /// <summary><para>method outline:</para>
        /// <para>演算モデルクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalModel csCalModel = CreateCalModel(csModelKind) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>演算モデルクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalModel CreateCalModel(HySObjectKind csModelKind)
        {
            McCalModel csCalModel = null;

            if (csModelKind == KinematicWaveRiverDefine.KINEMATIC_WAVE_River_KIND)
            {
                csCalModel = new KinematicWaveRiverModel();
            }
          
            return csCalModel;
        }

        /// <summary><para>method outline:</para>
        /// <para>要素内演算中データクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalInfo csCalModel = CreateCalInfo( csModelKind ) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>要素内演算中データクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalInfo CreateCalInfo(HySObjectKind csModelKind)
        {
            McCalInfo csCalInfoData = null;

            if (csModelKind == KinematicWaveRiverDefine.KINEMATIC_WAVE_River_KIND)
            {
                csCalInfoData = new KinematicWaveRiverCalInfo();
            }

            return csCalInfoData;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデルプロパティ表示／設定情報クラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csPropertyInf = CreateModelPropertyInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>モデルプロパティ表示／設定情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCellModelPropertyIF CreateModelProperty(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            McCellModelPropertyInfo csRtnCellPrptyDt = null;


            
            
            if (csModelKind == KinematicWaveRiverDefine.KINEMATIC_WAVE_River_KIND)
            {   // 流出解析 KinematicWave法
                csRtnCellPrptyDt = new McCellModelPropertyInfo(csLibraryID, csModelKind);

                csRtnCellPrptyDt.SetStepTime((double)60); // δT設定
                //csRtnCellPrptyDt.SetStepTime((double)48 * 3600 / 2400); // δT設定

                csRtnCellPrptyDt.AddInfoType("m_lCelNumber", Properties.Resources.STRING_CELNUMBER , McDefine.ValKind.LONG);
                csRtnCellPrptyDt.SetInfo("m_lCelNumber", 60);
                csRtnCellPrptyDt.AddInfoType("m_dLength", Properties.Resources.STRING_LENGTH, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dLength", 100000.0);//1000->100000
                csRtnCellPrptyDt.AddInfoType("m_dWidth", Properties.Resources.STRING_WIDTH, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dWidth", 200.0);//50->200
                csRtnCellPrptyDt.AddInfoType("m_dSlope", Properties.Resources.STRING_SLOPE, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dSlope", 1.0 / 2000.0);
                csRtnCellPrptyDt.AddInfoType("m_dRough", Properties.Resources.STRING_ROUGHNESS, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dRough", 0.03);
                csRtnCellPrptyDt.AddInfoType("m_inLQ", Properties.Resources.STRING_INFLOW, McDefine.ValKind.LONG);
                csRtnCellPrptyDt.SetInfo("m_inLQ", 30);

                // -----------------------
                //csRtnCellPrptyDt.AddInfoType("m_inLQ", "横流入させる斜面位置(斜面上流からの分割NO）", McDefine.ValKind.LONG);
                //csRtnCellPrptyDt.SetInfo("m_inLQ", 20);
                // -----------------------

                
                
                
                // 受信可能なパターン
                {
                    // 第１パターン(上流端・一次元)
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveRiverDefine.IN_PATTERN_TOP,
//                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.STRING_INPUT_CATEGORY) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_FLOWRATE, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec"); // 最初の変数は流量
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);    // 受信可能パターンの追加
                    // 第２パターン(横流入・一次元)
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveRiverDefine.IN_PATTERN_LATERAL,
//                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.STRING_INPUT_LATERAL) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_FLOWRATE, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec"); // 最初の変数は流量
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);    // 受信可能パターンの追加

                    // 第３パターン(上流端・ポイント)
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveRiverDefine.IN_PATTERN_TOP_P,
                        //                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        Properties.Resources.STRING_INPUT_CATEGORY) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_FLOWRATE, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec"); // 最初の変数は流量
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);    // 受信可能パターンの追加
                    // 第４パターン(横流入・ポイント)
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveRiverDefine.IN_PATTERN_LATERAL_P,
                        //                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        Properties.Resources.STRING_INPUT_LATERAL) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_FLOWRATE, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec"); // 最初の変数は流量
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);    // 受信可能パターンの追加
                }
                // 送信パターンの設定
                {
                    // 第１パターン(全体、一次元)
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveRiverDefine.OUT_PATTERN_ALL,
                        McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.STRING_OUTPUT_CELL) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_FLOWRATE, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec");
                            csCellChara.SetDataKind(1, Properties.Resources.STRING_WLEVEL, HySDataKindDefine.WATER_LEVEL, "m");
                            csCellChara.SetDataKind(2, Properties.Resources.STRING_VELOCITY, HySDataKindDefine.SCALOR_VELOCITY, "m/sec");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);
                    // 第２パターン(下流端、一次元)
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveRiverDefine.OUT_PATTERN_BOTTOM_1D,
                        McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.STRING_OUTPUT_CATEGORY) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_FLOWRATE, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec");
                            csCellChara.SetDataKind(1, Properties.Resources.STRING_WLEVEL, HySDataKindDefine.WATER_LEVEL, "m");
                            csCellChara.SetDataKind(2, Properties.Resources.STRING_VELOCITY, HySDataKindDefine.SCALOR_VELOCITY, "m/sec");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);
                    // 第３パターン(下流端、ポイント)
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        KinematicWaveRiverDefine.OUT_PATTERN_BOTTOM,
                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        Properties.Resources.STRING_OUTPUT_CATEGORY) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_FLOWRATE, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec");
                            csCellChara.SetDataKind(1, Properties.Resources.STRING_WLEVEL, HySDataKindDefine.WATER_LEVEL, "m");
                            csCellChara.SetDataKind(2, Properties.Resources.STRING_VELOCITY, HySDataKindDefine.SCALOR_VELOCITY, "m/sec");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);
                    // 第＊パターン(全体or任意の一点、ポイント)
                    /*
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                       KinematicWaveRiverDefine.OUT_PATTERN_ALL_P,
                        McTranInfoDefine.SINGLE_CELL_SERIAL,
                        Properties.Resources.STRING_OUTPUT_CELL) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_FLOWRATE, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec");
                            csCellChara.SetDataKind(1, Properties.Resources.STRING_WLEVEL, HySDataKindDefine.WATER_LEVEL, "m");
                            csCellChara.SetDataKind(2, Properties.Resources.STRING_VELOCITY, HySDataKindDefine.SCALOR_VELOCITY, "m/sec");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);
                    */
                }
            }

            return csRtnCellPrptyDt;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデル初期化表示／設定情報生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csInitialInf = CreateModelInitialInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>初期情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McPropertyInfoRoot CreateModelInitialInfo(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            McInitialInfo csRtnDt = null;

            if (csModelKind == KinematicWaveRiverDefine.KINEMATIC_WAVE_River_KIND)
            {
                csRtnDt = new McInitialInfo(csLibraryID, csModelKind);

                // ☆削除　csRtnDt.AddInfoType("H_Initial", "水深初期値(m)", McDefine.ValKind.DOUBLE);
                // ☆削除　csRtnDt.SetInfo("H_Initial", 1.19);
                csRtnDt.AddInfoType("Q_Initial", Properties.Resources.STRING_QINIT, McDefine.ValKind.DOUBLE);
                csRtnDt.SetInfo("Q_Initial", 200.0);
                // ☆削除　csRtnDt.AddInfoType("V_Initial", "流速初期値(m/s)", McDefine.ValKind.DOUBLE);
                // ☆削除　csRtnDt.SetInfo("V_Initial", 0.83);
            }
            return csRtnDt;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデル情報提供</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>HySDataLinkedList csModelInfoList = GetCalModelInfoList();</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>モデル情報のリスト</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>モデル情報(McModelInfo)をリスト形式で返却する</para>
        /// </remarks>
        public override HySDataLinkedList GetCalModelInfoList()
        {
            McModelInfo csModelInfo=null;

            

            csModelInfo = new McModelInfo(
                    (HySID)this.GetFactoryID(),
                    McModelLibraryDefine.DIVISION_CALCULATION_MODEL,
//                    McModelLibraryDefine.MODEL_CLASSIFICATION_CAL_RIVER,
                    new HySObjectKind("CAL_RIVER_MODELS"), // <-- LibraryCategoryXML.xmlに定義されている値を使用する
                    KinematicWaveRiverDefine.KINEMATIC_WAVE_River_KIND,
                    KinematicWaveRiverDefine.KINEMATIC_WAVE_River_NAME);
            csModelInfo.SetVersionInf("Ver1.0 ");
            csModelInfo.SetSummaryInf(Properties.Resources.STRING_SUMINF);
            csModelInfo.SetCreatorInf(Properties.Resources.STRING_CREATOR);
            csModelInfo.SetIconName("jp.or.jccajsce.KinematicWaveRiver");
            csModelInfo.SetManualFileName(@"jp.or.jccajsce.KinematicWaveRiver.pdf"); // <-- モデル解説書
            m_csCalModelInforList.AddLast(csModelInfo);


            return m_csCalModelInforList;
        }

    }
}
